/**
 * @(#)JUTree.java 0.0 24-10-2006
 * JUTree is a tree for java applications, something like JTree. 
 * You can make it's entries tickable. Its icons can be easily changed. 
 * Supports keyboard. A simple and compact program. 
 * You can change any of the tree's property anytime.
 *
 * @author Shashank Tulsyan
 * @version 0.0
 */
import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.plaf.*;
import javax.swing.event.*;
import javax.swing.plaf.basic.*;
import javax.swing.filechooser.FileView;
import javax.swing.filechooser.FileSystemView;
public class JUTree extends JComponent implements MouseListener,MouseMotionListener,KeyListener{
	/** A single variable that stores all information */
	protected char[][][]s;
	protected char[]heading,cmd;
	private int maxw,i,effl,ki,ticked,index;
	private FileView fv;
	private FileFilter ff;
	private File f;
	private HyperlinkListener al;
	private boolean expanded,onH,enablekeyboardcompatibitlity,showheading,chg,fiv;
	ImageIcon clo,col,exp,ope,tic,uxi;
	/**
	 * Default Constructor.
	 * You can change any of the tree's property anytime.
	 */
	public JUTree(){this(null,true,0,null,null,null,null,true,false,null);}
	/**
	 * @param heading The heading of the tree, pass null to disable showing of heading.
	 */
	public JUTree(String heading){this(heading,true,0,null,null,null,null,true,false,null);}
	/**
	 * @param heading  The heading of the tree, pass null to disable showing of heading.
	 * @param expanded  Pass true to have an initially expanded tree & vice-versa
	 */
	public JUTree(String heading,boolean expanded){this(heading,expanded,0,null,null,null,null,true,false,null);}
	/**
	 * @param heading  The heading of the tree, pass null to disable showing of heading.
	 * @param expanded  Pass true to have an initially expanded tree & vice-versa
	 * @param ticked  Used to set the initial ticked phase of the tree. Use JUTree.TICKED,JUTree.NOT_TICKED,JUTree.CANNOT_BE_TICKED
	 * @see JUTree#TICKED
	 * @see JUTree#NOT_TICKED
	 * @see JUTree#CANNOT_BE_TICKED
	 */
	public JUTree(String heading,boolean expanded,int ticked){this(heading,expanded,ticked,null,null,null,null,true,true,null);}//
	/**
	 * @param heading  The heading of the tree, pass null to disable showing of heading.
	 * @param expanded  Pass true to have an initially expanded tree & vice-versa
	 * @param ticked  Used to set the initial ticked phase of the tree. Use JUTree.TICKED,JUTree.NOT_TICKED,JUTree.CANNOT_BE_TICKED
	 * @param img  The array of IconImages. Length = 6. Pass null to use default, or pass null at some individual index.
	 * @param img[0]=directory closed image
	 * @param img[1]=colapsed directory tree image
	 * @param img[2]=expanded directory tree image
	 * @param img[3]=directory opened image
	 * @param img[4]=tick image
	 * @param img[5]=unexpandable item image, If this is null, the system is asked for the deafult icon. 
	 * @param So it is preferred to pass this null for a SystemLookAndFeel effect.
	 * @see JUTree#TICKED
	 * @see JUTree#NOT_TICKED
	 * @see JUTree#CANNOT_BE_TICKED
	 */
	public JUTree(String heading,boolean expanded,int ticked,ImageIcon[]img){this(heading,expanded,ticked,img,null,null,null,true,false,null);}
	/**
	 * @param heading  The heading of the tree, pass null to disable showing of heading.
	 * @param expanded  Pass true to have an initially expanded tree & vice-versa
	 * @param ticked  Used to set the initial ticked phase of the tree. Use JUTree.TICKED,JUTree.NOT_TICKED,JUTree.CANNOT_BE_TICKED
	 * @param img  The array of IconImages. Length = 6. Pass null to use default, or pass null at some individual index.
	 * @param 	img[0]=directory closed image
	 * @param 	img[1]=colapsed directory tree image
	 * @param 	img[2]=expanded directory tree image
	 * @param 	img[3]=directory opened image
	 * @param 	img[4]=tick image
	 * @param 	img[5]=unexpandable item image, If this is null, the system is asked for the deafult icon. 
	 * @param 		So it is preferred to pass this null for a SystemLookAndFeel effect.
	 * @param f  File object of the directory from where the tree has to be made.
	 * @see JUTree#TICKED
	 * @see JUTree#NOT_TICKED
	 * @see JUTree#CANNOT_BE_TICKED
	 */
	public JUTree(String heading,boolean expanded,int ticked,ImageIcon[]img,File f){this(heading,expanded,ticked,img,f,null,null,true,false,null);}
	/**
	 * @param heading  The heading of the tree, pass null to disable showing of heading.
	 * @param expanded  Pass true to have an initially expanded tree & vice-versa
	 * @param ticked  Used to set the initial ticked phase of the tree. Use JUTree.TICKED,JUTree.NOT_TICKED,JUTree.CANNOT_BE_TICKED
	 * @param img  The array of IconImages. Length = 6. Pass null to use default, or pass null at some individual index.
	 * @param 	img[0]=directory closed image
	 * @param 	img[1]=colapsed directory tree image
	 * @param 	img[2]=expanded directory tree image
	 * @param 	img[3]=directory opened image
	 * @param 	img[4]=tick image
	 * @param 	img[5]=unexpandable item image, If this is null, the system is asked for the deafult icon. 
	 * @param 		So it is preferred to pass this null for a SystemLookAndFeel effect.
	 * @param f  File object of the directory from where the tree has to be made.
	 * @param ff  The java.io.FileFilter used for filtering out undesired files while making the tree.
	 * @see JUTree#TICKED
	 * @see JUTree#NOT_TICKED
	 * @see JUTree#CANNOT_BE_TICKED
	 */
	public JUTree(String heading,boolean expanded,int ticked,ImageIcon[]img,File f,FileFilter ff){this(heading,expanded,ticked,img,f,ff,null,true,false,null);}
	/**
	 * @param heading  The heading of the tree, pass null to disable showing of heading.
	 * @param expanded  Pass true to have an initially expanded tree & vice-versa
	 * @param ticked  Used to set the initial ticked phase of the tree. Use JUTree.TICKED,JUTree.NOT_TICKED,JUTree.CANNOT_BE_TICKED
	 * @param img  The array of IconImages. Length = 6. Pass null to use default, or pass null at some individual index.
	 * @param 	img[0]=directory closed image
	 * @param 	img[1]=colapsed directory tree image
	 * @param 	img[2]=expanded directory tree image
	 * @param 	img[3]=directory opened image
	 * @param 	img[4]=tick image
	 * @param 	img[5]=unexpandable item image, If this is null, the system is asked for the deafult icon. 
	 * @param 		So it is preferred to pass this null for a SystemLookAndFeel effect.
	 * @param f  File object of the directory from where the tree has to be made.
	 * @param ff  The java.io.FileFilter used for filtering out undesired files while making the tree.
	 * @param fv  This javax.swing.filechooser.FileView if you want to have icons depending on type of file. This overtakes IconImage img[].
	 * @see JUTree#TICKED
	 * @see JUTree#NOT_TICKED
	 * @see JUTree#CANNOT_BE_TICKED
	 */
	public JUTree(String heading,boolean expanded,int ticked,ImageIcon[]img,File f,FileFilter ff,FileView fv){this(heading,expanded,ticked,img,f,ff,fv,false,false,null);}
	/**
	 * @param heading  The heading of the tree, pass null to disable showing of heading.
	 * @param expanded  Pass true to have an initially expanded tree & vice-versa
	 * @param ticked  Used to set the initial ticked phase of the tree. Use JUTree.TICKED,JUTree.NOT_TICKED,JUTree.CANNOT_BE_TICKED
	 * @param img  The array of IconImages. Length = 6. Pass null to use default, or pass null at some individual index.
	 * @param 	img[0]=directory closed image
	 * @param 	img[1]=colapsed directory tree image
	 * @param 	img[2]=expanded directory tree image
	 * @param 	img[3]=directory opened image
	 * @param 	img[4]=tick image
	 * @param 	img[5]=unexpandable item image, If this is null, the system is asked for the deafult icon. 
	 * @param 		So it is preferred to pass this null for a SystemLookAndFeel effect.
	 * @param f  File object of the directory from where the tree has to be made.
	 * @param ff  The java.io.FileFilter used for filtering out undesired files while making the tree.
	 * @param fv  This javax.swing.filechooser.FileView if you want to have icons depending on type of file. This overtakes IconImage img[].
	 * @param showheading  if true heading of the tree is shown.
	 * @see JUTree#TICKED
	 * @see JUTree#NOT_TICKED
	 * @see JUTree#CANNOT_BE_TICKED
	 */
	public JUTree(String heading,boolean expanded,int ticked,ImageIcon[]img,File f,FileFilter ff,FileView fv,boolean showheading){this(heading,expanded,ticked,img,f,ff,fv,showheading,false,null);}
	/**
	 * @param heading  The heading of the tree, pass null to disable showing of heading.
	 * @param expanded  Pass true to have an initially expanded tree & vice-versa
	 * @param ticked  Used to set the initial ticked phase of the tree. Use JUTree.TICKED,JUTree.NOT_TICKED,JUTree.CANNOT_BE_TICKED
	 * @param img  The array of IconImages. Length = 6. Pass null to use default, or pass null at some individual index.
	 * @param 	img[0]=directory closed image
	 * @param 	img[1]=colapsed directory tree image
	 * @param 	img[2]=expanded directory tree image
	 * @param 	img[3]=directory opened image
	 * @param 	img[4]=tick image
	 * @param 	img[5]=unexpandable item image, If this is null, the system is asked for the deafult icon. 
	 * @param 		So it is preferred to pass this null for a SystemLookAndFeel effect.
	 * @param f  File object of the directory from where the tree has to be made.
	 * @param ff  The java.io.FileFilter used for filtering out undesired files while making the tree.
	 * @param fv  This javax.swing.filechooser.FileView if you want to have icons depending on type of file. This overtakes IconImage img[].
	 * @param showheading  if true heading of the tree is shown.
	 * @param enablekeyboardcompatibility if true keyboard can also be used
	 * @param al  The javax.swing.event.HyperlinkListener which is invoked when any tree item is selected. The path is passed as a URL.
	 * @see JUTree#TICKED
	 * @see JUTree#NOT_TICKED
	 * @see JUTree#CANNOT_BE_TICKED
	 */
	public JUTree(String heading,boolean expanded,int ticked,ImageIcon[]img,File f,FileFilter ff,FileView fv,boolean showheading,boolean enablekeyboardcompatibitlity,HyperlinkListener al){
		this(heading,expanded,ticked,img,null,showheading,enablekeyboardcompatibitlity,al);
		if(ff==null)this.ff=new FileFilter(){public boolean accept(File f){return(f.isDirectory());}};
		else this.ff=ff;this.f=f;this.fv=null;
		if(fv==null){this.fv=new FileView(){
			public Icon getIcon(File df){return(FileSystemView.getFileSystemView().getSystemIcon(df));}
			public String getName(File df){return("");}public String getTypeDescription(File df){return("");}public Boolean isTraversable(File df){return(new Boolean(false));}public String getDescription(File df){return("");}};
		}else {this.fv=fv;fiv=true;}
		if(f!=null)makeTree(f);
	}
	/**
	 * You can make the entire tree using this contructor.
	 * If the origin of the tree is not a file but the program this contructor can be used.
	 * The structure of this array is complex. For details on the structure see -JUTree.setTree(char[][][]s)
	 * @param s - The 3 dim char array which makes the entire tree
	 * @see - JUTree#setTree
	 */
	public JUTree(char[][][]s){this("",true,0,null,s,false,false,null);}
	/**
	 * @param heading  The heading of the tree, pass null to disable showing of heading.
	 * @param expanded  Pass true to have an initially expanded tree & vice-versa
	 * @param ticked  Used to set the initial ticked phase of the tree. Use JUTree.TICKED,JUTree.NOT_TICKED,JUTree.CANNOT_BE_TICKED
	 * @param img  The array of IconImages. Length = 6. Pass null to use default, or pass null at some individual index.
	 * @param 	img[0]=directory closed image
	 * @param 	img[1]=colapsed directory tree image
	 * @param 	img[2]=expanded directory tree image
	 * @param 	img[3]=directory opened image
	 * @param 	img[4]=tick image
	 * @param 	img[5]=unexpandable item image, If this is null, the system is asked for the deafult icon. 
	 * @param 		So it is preferred to pass this null for a SystemLookAndFeel effect.
	 * @param s  The 3 dim char array which makes the entire tree
	 * @param showheading  if true heading of the tree is shown.
	 * @param enablekeyboardcompatibility if true keyboard can also be used
	 * @param al  The javax.swing.event.HyperlinkListener which is invoked when any tree item is selected. The path is passed as a URL.
	 * @see JUTree.TICKED
	 * @see JUTree.NOT_TICKED
	 * @see JUTree.CANNOT_BE_TICKED
	 */
	public JUTree(String heading,boolean expanded,int ticked,ImageIcon[]img,char[][][]s,boolean showheading,boolean enablekeyboardcompatibitlity,HyperlinkListener al){
		maxw=i=effl=ki=index=0;
		this.expanded=expanded;this.ticked=ticked;
		onH=false;this.showheading=showheading;chg=false;
		this.enablekeyboardcompatibitlity=enablekeyboardcompatibitlity;
		if(heading!=null)this.heading=heading.toCharArray();
		else this.heading=new char[0];
		if(al!=null)this.al=al; else al=null; cmd=new String("JUTree").toCharArray();
		if(img==null){clo=new ImageIcon(getClass().getResource("images/clo.gif"));col=new ImageIcon(JUTree.class.getResource("images/col.gif"));
			exp=new ImageIcon(JUTree.class.getResource("images/exp.gif"));ope=new ImageIcon(JUTree.class.getResource("images/ope.gif"));
			tic=new ImageIcon(JUTree.class.getResource("images/tic.gif"));uxi=null;
		}else if(img.length==6){
			if(img[0]!=null)clo=img[0]; else clo=new ImageIcon(JUTree.class.getResource("images/clo.gif"));if(img[1]!=null)col=img[1]; else col=new ImageIcon(JUTree.class.getResource("images/col.gif"));
			if(img[2]!=null)exp=img[2]; else exp=new ImageIcon(JUTree.class.getResource("images/exp.gif"));if(img[3]!=null)ope=img[3];	else ope=new ImageIcon(JUTree.class.getResource("images/ope.gif"));
			if(img[4]!=null)tic=img[4]; else tic=new ImageIcon(JUTree.class.getResource("images/tic.gif"));if(img[5]!=null)uxi=img[5]; else uxi=null;
		}else throw new ArrayIndexOutOfBoundsException(
			"Length should be exactly equal to 6.\n"+"The order of images being :\n"+
			"	img[0]=directory closed image\n"+"	img[1]=colapsed directory tree image\n"+
			"	img[2]=expanded directory tree image\n"+"	img[3]=directory opened image\n"+
			"	img[4]=tick image\n"+"	img[5]=unexpandable item image\n"+
			"If at any index(0-5) image == null default image will be used.\nSo you can change only the images you desire.\n"+
			"Or pass entire array as null to enable usage of default L&F independant images."
		);
		addMouseListener(this);fiv=false;
		if(showheading)addMouseMotionListener(this);
		if(enablekeyboardcompatibitlity){addKeyListener(this);requestFocus();}
		if(getBounds()==null)setBounds(0,0,0,0);
		if(s!=null)this.s=s;
		else s=new char[0][5][0];
	}
	public void paintComponent(Graphics g){
		if(enablekeyboardcompatibitlity)requestFocus();
		g.setColor(Color.WHITE);
		g.fillRect(0,0,maxw,effl*17+25);
		g.fillRect(0,0,new Double(getBounds().getWidth()).intValue(),new Double(getBounds().getHeight()).intValue());
		g.setColor(Color.BLACK);
		Font t=g.getFont();
		if(showheading){
			g.setFont(new Font(t.getName(),Font.BOLD,t.getSize()+4));
			g.drawChars(heading,0,heading.length,12,12);
			if(onH)g.drawLine(12,12,
				(int)Math.rint(heading.length*g.getFont().getSize()*2/3)
			,12);
			g.setFont(t);
		}for(int j=0,i=0;j<s.length&&i<s.length;j++){
			if(al!=null&&i==index)g.setFont(new Font(t.getName(),Font.ITALIC,t.getSize()));
			else g.setFont(t);
			g.drawChars(s[i][1],0,s[i][1].length,ti(s[i][0])*19+10+17,j*17+25);
			if(i==ki&&enablekeyboardcompatibitlity)
				g.drawLine(ti(s[i][0])*19+10+17,j*17+25,
				(int)Math.rint(s[i][1].length*g.getFont().getSize()*1/2)
				+ti(s[i][0])*19+10+17
			,j*17+25);
			if(s[i][3].length==0){
				g.drawImage(exp.getImage(),ti(s[i][0])*19,j*17+15+4,9,9,exp.getImageObserver());
				if(!fiv)g.drawImage(ope.getImage(),ti(s[i][0])*19+10,j*17+15,16,16,exp.getImageObserver());
				else fv.getIcon(new File(new String(s[i][4]))).paintIcon(this,g,ti(s[i][0])*19+10,j*17+15);
				if(s[i][2].length==0) 
					g.drawImage(tic.getImage(),ti(s[i][0])*19+10+7,j*17+15,9,9,exp.getImageObserver());
				i++;
			}else {
				if(s[i][3].length==1){
					g.drawImage(col.getImage(),ti(s[i][0])*19,j*17+15+4,9,9,exp.getImageObserver());
					if(!fiv)g.drawImage(clo.getImage(),ti(s[i][0])*19+10,j*17+15,16,16,exp.getImageObserver());
					else fv.getIcon(new File(new String(s[i][4]))).paintIcon(this,g,ti(s[i][0])*19+10,j*17+15);
				}else{if(uxi!=null)g.drawImage(uxi.getImage(),ti(s[i][0])*19+10,j*17+15,16,16,exp.getImageObserver());
				else fv.getIcon(new File(new String(s[i][4]))).paintIcon(this,g,ti(s[i][0])*19+10,j*17+15);
				}
				if(s[i][2].length==0) 
					g.drawImage(tic.getImage(),ti(s[i][0])*19+10+7,j*17+15,9,9,exp.getImageObserver());
				int k=i;
				for(;k<s.length&&new String(s[k][0]).startsWith(new String(s[i][0]));k++);
				i=k;
			}
		}g.dispose();System.gc();
	}
	public Dimension getPreferredSize(){return(new Dimension(maxw,effl*17+25));}
	public Dimension getMaximumSize(){return(new Dimension(maxw,s.length*17+25));}
	public Dimension getMinimumSize(){return(new Dimension(0,0));}
	public void mouseClicked(MouseEvent e){
		int x=e.getX(),y=e.getY(),j1=(int)Math.rint((y-15)/17);
		if(y<15){
			if(ticked!=2&&!showheading)
				for(int j=0;j<s.length;j++)
					s[j][2]=new char[0]; 
					repaint(); 
			if(al!=null)if(f!=null){try{
				al.hyperlinkUpdate(new HyperlinkEvent(this,HyperlinkEvent.EventType.ACTIVATED,f.toURL(),new String(cmd)));}catch(Exception na){}}
		}
		for(int j=0,i=0;j<s.length&&i<s.length;j++){
			if(j==j1){
				if(x>=ti(s[i][0])*19-10&&x<=ti(s[i][0])*19+9){
					if(s[i][3].length==1)s[i][3]=new char[0];
					else if(s[i][3].length==0)s[i][3]=new char[1];
					resized();
				}else if(x>=ti(s[i][0])*19+10&&x<=ti(s[i][0])*19+10+14+s[i][1].length*4){
					if(ticked!=2){
						if(s[i][2].length==1)s[i][2]=new char[0];
						else if(s[i][2].length==0)s[i][2]=new char[1];
						ticChange(i,0);
					}
					if(al!=null){
						try{
						al.hyperlinkUpdate(new HyperlinkEvent(
							this,
							HyperlinkEvent.EventType.ACTIVATED,
							new File(new String(s[i][4])).toURL(),
							new String(cmd)));
						}catch(Exception anyw){}
						index=i;
					}if(enablekeyboardcompatibitlity&&al!=null)ki=index;
				}repaint();break;
			}
			if(s[i][3].length==1){
				int k=i;
				for(;k<s.length&&new String(s[k][0]).startsWith(new String(s[i][0]));k++);i=k;
			}else i++;
		}
	}
	public void mouseMoved(MouseEvent e){
		if(e.getY()<15&&showheading){onH=true;repaint();}
		else {if(onH){onH=false;repaint();} onH=false;}		
		if(al!=null){
			int x=e.getX(),y=e.getY(),j1=(int)Math.rint((y-15)/17);
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			chg=false;
			if(y<15)chg=true;
			for(int j=0,i=0;j<s.length&&i<s.length;j++){
				if(j==j1)
					if(x>=ti(s[i][0])*19+10&&x<=ti(s[i][0])*19+10+14+s[i][1].length*4)
						chg=true;
				if(s[i][3].length==1){
					int k=i;
					for(;k<s.length&&new String(s[k][0]).startsWith(new String(s[i][0]));k++);i=k;}else i++;
			}
		}
		if(chg)setCursor(new Cursor(Cursor.HAND_CURSOR));
	}
	public void keyReleased(KeyEvent e){
		boolean r;
		if(ki<0||ki>s.length-1)ki=0;
		switch(e.getKeyCode()){
			case KeyEvent.VK_DOWN:{
				if(ki==s.length-1)return;
				r=false;
				for(int j=0;j<s.length;){
					if(j==ki)r=true;
					if(s[j][3].length==1){
						int k=j+1;
						for(;k<s.length&&new String(s[k][0]).startsWith(new String(s[j][0]));k++);
						j=k;
					}else j++;
					if(r){ki=j;if(enablekeyboardcompatibitlity&&al!=null)index=ki;break;}
				}
				repaint();
				break;
			}
			case KeyEvent.VK_UP:{
				int li=0;
				if(ki==0)return;
				for(int j=0;j<s.length;){
					if(j==ki){
						ki=li;
						if(enablekeyboardcompatibitlity&&al!=null)
							index=ki;
						break;
					}li=j;
					if(s[j][3].length==1){
						int k=j+1;
						for(;k<s.length&&new String(s[k][0]).startsWith(new String(s[j][0]));k++);
						j=k;
					}
					else j++;
				}
				repaint();
				break;
			}
			case KeyEvent.VK_SPACE:{
				for(int j=0;j<s.length;){
					if(j==ki){
						if(s[j][2].length==1)
							s[j][2]=new char[0];
						else if(s[j][2].length==0)
							s[j][2]=new char[1];
						if(al!=null)
						try{al.hyperlinkUpdate(new HyperlinkEvent(this,HyperlinkEvent.EventType.ACTIVATED,new File(new String(s[ki][4])).toURL(),new String(cmd)));}
						catch(Exception any){}
						break;
					}
					if(s[j][3].length==1){
						int k=j+1;
						for(;k<s.length&&new String(s[k][0]).startsWith(new String(s[i][0]));k++);
						j=k;
					}
					else j++;
				}
				repaint();
				break;
			}
			default:{}
		}
	}
	public void keyPressed(KeyEvent e){}public void keyTyped(KeyEvent e){}
	public void mouseDragged(MouseEvent e){}public void mousePressed(MouseEvent e){}public void mouseReleased(MouseEvent e){}public void mouseExited(MouseEvent e){}public void mouseEntered(MouseEvent e){}
	/**
	 * Adds an tree element at i
	 *@param i  The index where an elements should be added
	 */
	public void addAt(int i){addAt(i,new char[0]);}
	/**
	 * Adds an tree element at i
	 *@param i  The index where an elements should be added
	 *@param nm The name of the item going to be added
	 */
	public void addAt(int i,char[]nm){
		int l=0;
		for(int j=0;j<s.length;j++)
			if(Integer.parseInt(new String(s[j][0]).substring(2,3))>l)
				l=Integer.parseInt(new String(s[j][0]).substring(2,3));
		if(i>l)return;
		char[][][]s1=s;
		s=new char[s1.length+1][5][0];
		int j=0;
		for(;j<Integer.parseInt(new String(s[j][0]).substring(2,3));j++)
			s[j]=s1[j];
		s[j][1]=nm; 
		s[j][0]=new String(0+"."+(Integer.parseInt(new String(s[j][0]).substring(2,3))+1)).toCharArray();
		s[j][2]=new char[0];
		s[j][3]=new char[2];
		s[j][4]=new String(nm).toCharArray();
		for(int k=j;k<s.length;k++)
			s[k]=s1[k-1];
	}
	/**
	 * Use this to get all information about the whole tree.
	 * For details on the structure of the array refer to JUTree.setTree(char[][][]s)
	 * @return The 3 dim char array containing all information about the tree.
	 * @see JUTree#setTree
	 */
	public char[][][]getTree(){
		char[][][]s1=new char[s.length][s[0].length][0];
		for(int j=0;j<s.length;j++)
			for(int k=0;k<s[j].length;k++)
				s1[j][k]=new char[s[j][k].length];
		for(int j=0;j<s.length;j++)
			for(int k=0;k<s[j].length;k++)
				for(int l=0;l<s[j][k].length;l++)
					s1[j][k][l]=s[j][k][l];
		return(s1);
	}
	/**
	 * Use this to get all information (passed without breaking reference) about the whole tree. 
	 * For details on the structure of the array refer to JUTree.setTree(char[][][]s)
	 * @return The 3 dim char array containing all information about the tree.
	 * @see JUTree#setTree
	 */
	protected char[][][]getTreeByReference(){return(s);}
	/**
	 * Use this to set the tree.
	 * Sturcture of char[][][]s 
	 * [0] location - reflect the relative position of the element. Ex- 0.0,0.0.1,0.1.0.1 would be like
	 * <html>
	 * <IMG SRC="./tree.gif"></IMG>
	 * </html>
	 * [1] display name - The display name of the item
	 * [2] checked - length=0=>checked,1=>not checked & 2 or null => not checkable
	 * [3] expaned - length=0=>expanded,1=>not expanded & 2 or null => not expandable
	 * [4] folder name/absolute path/other useful description
	 */
	public void setTree(char[][][]s1){
		s=new char[s1.length][s[0].length][0];
		for(int j=0;j<s1.length;j++)
			for(int k=0;k<s1[j].length;k++)
				s1[j][k]=new char[s[j][k].length];
		for(int j=0;j<s1.length;j++)
			for(int k=0;k<s1[j].length;k++)
				for(int l=0;l<s1[j][k].length;l++)
					s[j][k][l]=s1[j][k][l];
		resized();
	}
	/**
	 * Use this to set the whole tree (reference not broken).
	 * For details on the structure of the array refer to JUTree.setTree(char[][][]s)
	 * @return The 3 dim char array containing all information about the tree.
	 * @see JUTree#setTree
	 */
	protected void setTreeByReference(char[][][]s1){s=s1;resized();}
	/**
	 * Sets the heading of the tree
	 * @param h  the heading of the tree
	 */
	public void setHeading(String h){heading=h.toCharArray();showheading=(heading!=null);}
	/**
	 * Returns the heading of the tree
	 * Set heading to null to disable 'all ticked when heading clicked' property.
	 * @return Heading of the tree
	 */ 
	public String getHeading(){return(new String(heading));}
	/**
	 * Sets the name of entry at i
	 * @param i  The index of the element whose name is to be set.
	 * @param nm  Name of the entry
	 */
	public void setNameAt(int i,char[]nm){if(i<s.length)s[i][1]=nm;else s[i][1]=null;}
	/**
	 * Returns the name of entry at i
	 * @param i  The index of the element whose name is required.
	 * @param nm  The char array where the name gets stored
	 */
	public void getNameAt(int i,char[]nm){if(i<s.length)nm=s[i][1];else nm=null;}
	/**
	 * Returns an String array containing the relative path of files from the origin directory according to the FileFilter
	 * @param fx  java.io.FileFilter which accepts the desired files
	 * @return A String Array containing containing the relative path of files from the origin directory according to the FileFilter
	 */	 
	public String[]getTerminals(FileFilter fx){if(fx==null)fx=new FileFilter(){public boolean accept(File e){return(e.getName().endsWith(".exe")||e.getName().endsWith(".jar")||e.getName().endsWith(".com")||e.getName().endsWith(".class")||e.isDirectory());}};String[]d=new String[getNodes(this.f,fx)];setNodes(this.f,fx,d,0);return(d);}
	/**
	 * Returns an String array containing the names of all entries
	 * @return fx  java.io.FileFilter which accepts the desired files
	 */
	public String[]getNames(){String[]a=new String[s.length];for(int j=0;j<s.length;j++)a[j]=new String(s[j][4]);return(a);}
	/**
	 * Returns the entry at index i
	 * @param i  The index of the required entry
	 * @return Returns the entry at index i
	 */	
	public char[][]getEntryAt(int i){if(i<s.length)return(s[i]);else return(null);}
	/**
	 * Returns the property of the table at [i][j]
	 * @param i  The index of the entry
	 * @param j  The index of the property, refer to JUTree.setTree(char[][][]s) for more information
	 * @return Returns the property of the table at [i][j]
	 * @see JUTree#setTree
	 */
	public char[]getPropertyAt(int i,int j){if(i<s.length){char[]s1=new char[s[i][j].length];for(int k=0;k<s[i][j].length;k++)s1[k]=s[i][j][k];return(s1);}else return(null);}
	/**
	 * Sets the entry at index i
	 * @param i  The index of the required entry
	 * @param ent  The value to be set
	 */	
	public void setEntryAt(int i,char[][]ent){if(i<s.length)s[i]=ent;ticChange(i,1);}
	/**
	 * Sets the property of the table at [i][j]
	 * @param i  The index of the entry
	 * @param j  The index of the property, refer to JUTree.setTree(char[][][]s) for more information
	 * @ent  The 2 dim. array where the value is be saved
	 * @see JUTree#setTree
	 */
	public void setPropertyAt(int i,int j,char[]ent){if(i<s.length)s[i][j]=ent;ticChange(i,1);}
	/**
	 * Returns the current java.io.FileFilter being used
	 * @return Returns the current filefilter being used
	 */
	public FileFilter getFileFilter(){return(ff);}
	/**
	 * Sets the java.io.FileFilter being used to f
	 * @param f  The filefilter to be used
	 */
	public void setFileFilter(FileFilter f){if(f!=null)ff=f;}
	/**
	 * Adding hyperlinklistener results is firing of HyperlinkEvent everytime an element is clicked.
	 * Unlike some JComponents you cannot set more than one hyperlinklink listener.
	 * @param al  The the new hyperlinklistener to be set. 
	 * @param cmd  the description of the link. This may be useful when attempting to form a URL resulted in a MalformedURLException. The description provides the text used when attempting to form the URL.
	 */
	public void setHyperlinkListener(HyperlinkListener al,String cmd){if(al!=null)this.al=al;this.cmd=cmd.toCharArray();}
	/**
	 * Prints the tree elements in order of their occurence in the default STDOUT stream
	 */
	public void printTree(){printTree(System.out);}
	/**
	 * Prints the tree elements in order of their occurence in ps
	 * @param ps  The PrintStream where the tree would be printed
	 */
	public void printTree(PrintStream ps){for(int j=0;j<s.length;j++,ps.println())for(int k=0;k<s[j].length;ps.print(new String(s[j][k])+" "),k++);}
	/**
	 * Set the fileview to fv
	 * @param fv  The new javax.swing.filechooser.FileView
	 */
	public void setFileView(FileView fv){this.fv=fv;fiv=true;}
	/**
	 * Returns the current fileview
	 * @return Returns the current javax.swing.filechooser.FileView
	 */
	public FileView getFileView(){return(fv);}
	/**
	 * Pass true to enable usage of icons specified by the fileview or false to enable usage of icons of the image array.
	 * @param sd  The boolean value which determines usage of fileview or image array icons.
	 */
	public void useFileView(boolean sd){fiv=sd;}
	/** The default int value specifing that element is ticked*/
	public final static int TICKED=0;
	/** The default int value specifing that element is not ticked*/
	public final static int NOT_TICKED=1;
	/** The default int value specifing that element cannot be ticked*/
	public final static int CANNOT_BE_TICKED=2;
	/** The default int value specifing that element is expanded*/
	public final static int EXPANDED=0;
	/** The default int value specifing that element is not expanded*/
	public final static int NOT_EXPANDED=1;
	/** The default int value specifing that element cannot be expanded*/
	public final static int CANNOT_BE_EXPANDED=2;
	/**
	 * This is the preferred way of building the tree. Pass the origin directory from where a tree is made.
	 * @param dir  The origin directory from where the tree is created.
	 */
	public void makeTree(File dir){
		this.f=dir;i=0;s=new char[getDirs(dir)][5][0];
		setN(dir,"0");i=0;
		resized();
	}
	/**
	 * This is the preferred way of building the tree. Pass the origin directory from where a tree is made.
	 * @param dir  The origin directory from where the tree is created.
	 * @param ff  The FileFilter which is used to filter out undesired element.
	 */
	public void makeTree(File dir,FileFilter ff){
		this.ff=ff;this.f=dir;
		makeTree(dir);
	}
	private int getDirs(File f){
		int l=0;
		File[]fl=f.listFiles(ff);if(fl==null)return(0);
		for(int j=0;j<fl.length;j++,l++){
			if(fl[j].listFiles(ff)!=null)
				if(fl[j].listFiles(ff).length!=0)
					l+=getDirs(fl[j]);
		}return(l);
	}
	private void setN(File f,String d){
		File[]fl=f.listFiles(ff);if(fl==null)return;
		for(int j=0;j<fl.length;j++){
			s[i][0]=new String(d+"."+j).toCharArray();
			s[i][1]=new String(fl[j].getName()).toCharArray();
			if(ticked==0)s[i][2]=new char[0];
			else if(ticked==1)s[i][2]=new char[1];
			else s[i][2]=new char[2];
			s[i][4]=new String(fl[j].getAbsolutePath()).toCharArray();
			i++;
			if(fl[j].listFiles(ff)!=null){
				if(fl[j].listFiles(ff).length!=0){
					if(expanded)s[i-1][3]=new char[0];
					else s[i-1][3]=new char[1];
					setN(fl[j],d+"."+j);
				}else if(i-1<s.length)s[i-1][3]=new char[2];
			}else s[i-1][3]=new char[2];
		}
	}
	private int getNodes(File fe,FileFilter fx){
		int l=0;
		File[]fl=fe.listFiles(fx);if(fl==null)return(0);
		for(int j=0;j<fl.length;j++){
			if(fl[j].listFiles(fx)==null)l++;
			else {l+=getNodes(fl[j],fx);}
		}return(l);
	}private int setNodes(File fe,FileFilter fx,String[]ar,int index){
		File[]fl=fe.listFiles(fx);if(fl==null)return(0);
		for(int j=0;j<fl.length;j++){
			if(fl[j].listFiles(fx)==null){ar[index]=fl[j].getAbsolutePath().substring(f.getAbsolutePath().length());index++;}
			else{index=setNodes(fl[j],fx,ar,index);}
		}return(index);
	}
	private int ti(char[]t){int te=0; for(int j=0;j<t.length;j++)if(t[j]=='.')te++; return(te);}
	private void ticChange(int l,int t){
		for(int j=0;j<s.length;j++)
			if(s[j][2].length==1){
				int k=j+1;
				if(j==l&&s[j][2].length==0){
					s[j][2]=new char[0];
					return;
				}
				for(;k<s.length&&new String(s[k][0]).startsWith(new String(s[j][0]));k++){
					if(k!=l)s[k][2]=new char[1];
					else if(s[k][2].length==0){
						s[j][2]=new char[0];
						int times=ti(s[k][0])-ti(s[j][0]);
						for(int m=0;m<times;m++)ticChange(k,1);
						return;
					}
				}
				j=k-1;
			}else if(j==l&&t==0){
				int k=j+1;
				for(;k<s.length&&new String(s[k][0]).startsWith(new String(s[j][0]));k++)
					s[k][2]=new char[0];
				j=k-1;
			}
	}
	private void resized(){
		int j=0;
		for(int i=0;j<s.length&&i<s.length;j++){
			if((ti(s[i][0])+2)*19+s[i][1].length*7>maxw)
				maxw=(ti(s[i][0])+2)*19+s[i][1].length*7;
			if(s[i][3].length==1){
				int k=i;
				for(;k<s.length&&new String(s[k][0]).startsWith(new String(s[i][0]));k++);
				i=k;
			}else i++;
		}if(heading!=null)if(heading.length*9>maxw)maxw=heading.length*9;
		effl=j;
		revalidate();repaint();
	}
}